{$R+}
var
  a: array of Integer;

procedure Shuffle(l, r: Integer);
var
  i, j, t: Integer;
begin
  for i := l to r - 1 do begin
    j := i + Random(r - i);
    t := a[i];
    a[i] := a[j];
    a[j] := t;
  end;
end;

var
  N, K, M, d, i, j, len: Integer;
begin
  Val(ParamStr(1), N, i);
  Val(ParamStr(2), K, i);
  Val(ParamStr(3), M, i);
  Val(ParamStr(4), RandSeed, i);
  SetLength(a, N + 1);

  j := 1; len := Random(K) + 1; d := 1;
  for i := 1 to N do begin
    if j > len then begin
      Shuffle(i - j + 2, i);
      len := Random(K) + 1;
      d := Random(M) + 1;
      j := 1;
    end;
    a[i] := j + d;
    Inc(j);
  end;
  Shuffle(N - j + 2, N);

  Writeln(N);
  for i := 1 to N do Write(a[i], ' ');
  Writeln;
end.
