
var
  a: array of Integer;

procedure Shuffle(l, r: Integer);
var
  i, j, t: Integer;
begin
  for i := l to r - 1 do begin
    j := i + Random(r - i);
    t := a[i];
    a[i] := a[j];
    a[j] := t;
  end;
end;

var
  N, K, M, i, j: Integer;
begin
  Val(ParamStr(1), N, i);
  Val(ParamStr(2), K, i);
  Val(ParamStr(3), M, i);
  Val(ParamStr(4), RandSeed, i);
  SetLength(a, N + 1);

  for i := 1 to N do
    a[i] := 5;
  j := Random(N - K);
  for i := 1 to K do
    a[i + j] := i + M;
  Shuffle(j + 1, j + K);

  Writeln(N);
  for i := 1 to N do Write(a[i], ' ');
  Writeln;
end.
